{ Copyright (c) 2000 by Mandys Tomas - Mandy Soft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit convfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, UUEnc;

type
{  TProgressEvent = procedure (aPos, aMax: Longint) of object; }

  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ProgressBar1: TProgressBar;
    BitBtn2: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    StopFlag: Boolean;
    procedure ProgressEvent(aPos, aMax: Longint);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
resourcestring
  sFileExists = 'Target file already exists! Overwrite it?';
implementation
uses
  CZStr, CmdLine;

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  S1, S2: TStream;
  C: Char;
begin
  if FileExists(Edit1.Text) then  { kdyz neex. tak da pozdeji chybu }
    if FileExists(Edit2.Text) then
      if MessageDlg(sFileExists, mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
        Abort;
  StopFlag:= False;
  ProgressBar1.Visible:= True;
  ProgressBar1.Position:= 0;
  BitBtn1.Enabled:= False;
  BitBtn2.Enabled:= True;
  try
    S1:= TFileStream.Create(Edit1.Text, fmOpenRead);
    try
      S2:= TFileStream.Create(Edit2.Text, fmCreate);
      try
        if RadioGroup1.ItemIndex = 5 then
          _UUDecode(S1, S2, uuUU, ProgressEvent)
        else
        if RadioGroup2.ItemIndex = 5 then
          _UUEncode(S1, S2, uuUU, ProgressEvent)
        else
        if RadioGroup1.ItemIndex = 6 then
          _UUDecode(S1, S2, uuBase64, ProgressEvent)
        else
        if RadioGroup2.ItemIndex = 6 then
          _UUEncode(S1, S2, uuBase64, ProgressEvent)
        else
        if RadioGroup1.ItemIndex = 7 then
          _UUDecode(S1, S2, uuQuoted, ProgressEvent)
        else
        if RadioGroup2.ItemIndex = 7 then
          _UUEncode(S1, S2, uuQuoted, ProgressEvent)
        else
          while S1.Position < S1.Size do
          begin
            ProgressEvent(S1.Position, S1.Size);
            S1.ReadBuffer(C, SizeOf(C));
            C:= CZSwitchToC(RadioGroup1.ItemIndex, RadioGroup2.ItemIndex, C);
            S2.WriteBuffer(C, SizeOf(C));
          end;
      finally
        S2.Free;
      end;
    finally
      S1.Free;
    end;
  finally
    ProgressBar1.Visible:= False;
    BitBtn2.Enabled:= False;
    BitBtn1.Enabled:= True;
    if IsThereCmd('E', clUpcase) then
      Application.Terminate;
  end;
end;

procedure TForm1.Edit1DblClick(Sender: TObject);
var
  S: string;
begin
  S:= (Sender as TEdit).Text;
  if (S <> '') and (S[Length(S)] in [':','\']) then
    S:= S+' ';  // to open dialog
  OpenDialog1.FileName:= S;
  if OpenDialog1.Execute then
    (Sender as TEdit).Text:= OpenDialog1.FileName;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  S: string;
begin
  S:= '';
  GetCmdString('SF:', clUpcase, S);
  Edit1.Text:= S;
  S:= '';
  GetCmdString('TF:', clUpcase, S);
  Edit2.Text:= S;
  S:= '0';
  GetCmdString('SC:', clUpcase, S);
  RadioGroup1.ItemIndex:= StrToInt(S);
  S:= '0';
  GetCmdString('TC:', clUpcase, S);
  RadioGroup2.ItemIndex:= StrToInt(S);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if IsThereCmd('C', clUpcase) then
    BitBtn1Click(nil);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
var
  F: Boolean;
  RG: TRadioGroup;
begin
  if Sender = RadioGroup1 then RG:= RadioGroup2
                          else RG:= RadioGroup1;
  F:= (Sender as TRadioGroup).ItemIndex < 5;
  if not F then
    RG.ItemIndex:= 0;
  RG.Enabled:= F;
end;

procedure TForm1.ProgressEvent(aPos, aMax: Longint);
begin
  if StopFlag then
    Abort;
  ProgressBar1.Position:= aPos;
  ProgressBar1.Max:= aMax;
  Application.ProcessMessages;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  StopFlag:= True;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Edit1DblClick(Edit1);
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Edit1DblClick(Edit2);
end;

end.
